Index: /pjproject/trunk/pjlib/src/pj/ioqueue_uwp.cpp
===================================================================
--- /pjproject/trunk/pjlib/src/pj/ioqueue_uwp.cpp	(revision 5539)
+++ /pjproject/trunk/pjlib/src/pj/ioqueue_uwp.cpp	(revision 5539)
@@ -0,0 +1,336 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2016 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#include <pj/ioqueue.h>
+#include <pj/errno.h>
+#include <pj/lock.h>
+#include <pj/log.h>
+#include <pj/os.h>
+#include <pj/pool.h>
+
+#include <ppltasks.h>
+#include <string>
+
+#define THIS_FILE   "ioq_uwp"
+
+#include "sock_uwp.h"
+#include "ioqueue_common_abs.h"
+
+ /*
+ * This describes each key.
+ */
+struct pj_ioqueue_key_t
+{
+    DECLARE_COMMON_KEY
+};
+
+/*
+* This describes the I/O queue itself.
+*/
+struct pj_ioqueue_t
+{
+    DECLARE_COMMON_IOQUEUE
+    pj_thread_desc   thread_desc[16];
+    unsigned	     thread_cnt;
+};
+
+
+#include "ioqueue_common_abs.c"
+
+static void ioqueue_remove_from_set( pj_ioqueue_t *ioqueue,
+				     pj_ioqueue_key_t *key, 
+				     enum ioqueue_event_type event_type)
+{
+    PJ_UNUSED_ARG(ioqueue);
+    PJ_UNUSED_ARG(key);
+    PJ_UNUSED_ARG(event_type);
+}
+
+
+static void start_next_read(pj_ioqueue_key_t *key)
+{
+    if (key_has_pending_read(key)) {
+	PjUwpSocket *s = (PjUwpSocket*)key->fd;
+	struct read_operation *op;
+	op = (struct read_operation*)key->read_list.next;
+
+	if (op->op == PJ_IOQUEUE_OP_RECV)
+	    s->Recv(NULL, (pj_ssize_t*)&op->size);
+	else
+	    s->RecvFrom(NULL, (pj_ssize_t*)&op->size, NULL);
+    }
+}
+
+
+static void start_next_write(pj_ioqueue_key_t *key)
+{
+    if (key_has_pending_write(key)) {
+	PjUwpSocket *s = (PjUwpSocket*)key->fd;
+	struct write_operation *op;
+	op = (struct write_operation*)key->write_list.next;
+
+	if (op->op == PJ_IOQUEUE_OP_SEND)
+	    s->Send(op->buf, (pj_ssize_t*)&op->size);
+	else
+	    s->SendTo(op->buf, (pj_ssize_t*)&op->size, &op->rmt_addr);
+    }
+}
+
+
+static void ioqueue_add_to_set( pj_ioqueue_t *ioqueue,
+				pj_ioqueue_key_t *key,
+				enum ioqueue_event_type event_type )
+{
+    PJ_UNUSED_ARG(ioqueue);
+
+    if (event_type == READABLE_EVENT) {
+	/* This is either recv, recvfrom, or accept, do nothing on accept */
+	start_next_read(key);
+    } else if (event_type == WRITEABLE_EVENT) {
+	/* This is either send, sendto, or connect, do nothing on connect */
+	//start_next_write(key);
+    }
+}
+
+
+static void check_thread(pj_ioqueue_t *ioq) {
+    if (pj_thread_is_registered())
+	return;
+
+    pj_thread_t *t;
+    char tmp[16];
+    pj_ansi_snprintf(tmp, sizeof(tmp), "UwpThread%02d", ioq->thread_cnt);
+    pj_thread_register(tmp, ioq->thread_desc[ioq->thread_cnt++], &t);
+    pj_assert(ioq->thread_cnt < PJ_ARRAY_SIZE(ioq->thread_desc));
+    ioq->thread_cnt %= PJ_ARRAY_SIZE(ioq->thread_desc);
+}
+
+static void on_read(PjUwpSocket *s, int bytes_read)
+{
+    pj_ioqueue_key_t *key = (pj_ioqueue_key_t*)s->GetUserData();
+    pj_ioqueue_t *ioq = key->ioqueue;
+    check_thread(ioq);
+
+    ioqueue_dispatch_read_event(key->ioqueue, key);
+    
+    if (bytes_read > 0)
+	start_next_read(key);
+}
+
+static void on_write(PjUwpSocket *s, int bytes_sent)
+{
+    PJ_UNUSED_ARG(bytes_sent);
+    pj_ioqueue_key_t *key = (pj_ioqueue_key_t*)s->GetUserData();
+    pj_ioqueue_t *ioq = key->ioqueue;
+    check_thread(ioq);
+
+    ioqueue_dispatch_write_event(key->ioqueue, key);
+
+    //start_next_write(key);
+}
+
+static void on_accept(PjUwpSocket *s)
+{
+    pj_ioqueue_key_t *key = (pj_ioqueue_key_t*)s->GetUserData();
+    pj_ioqueue_t *ioq = key->ioqueue;
+    check_thread(ioq);
+
+    ioqueue_dispatch_read_event(key->ioqueue, key);
+}
+
+static void on_connect(PjUwpSocket *s, pj_status_t status)
+{
+    PJ_UNUSED_ARG(status);
+    pj_ioqueue_key_t *key = (pj_ioqueue_key_t*)s->GetUserData();
+    pj_ioqueue_t *ioq = key->ioqueue;
+    check_thread(ioq);
+
+    ioqueue_dispatch_write_event(key->ioqueue, key);
+}
+
+
+/*
+ * Return the name of the ioqueue implementation.
+ */
+PJ_DEF(const char*) pj_ioqueue_name(void)
+{
+    return "ioqueue-uwp";
+}
+
+
+/*
+ * Create a new I/O Queue framework.
+ */
+PJ_DEF(pj_status_t) pj_ioqueue_create(	pj_pool_t *pool, 
+					pj_size_t max_fd,
+					pj_ioqueue_t **p_ioqueue)
+{
+    pj_ioqueue_t *ioq;
+    pj_lock_t *lock;
+    pj_status_t rc;
+
+    PJ_UNUSED_ARG(max_fd);
+
+    ioq = PJ_POOL_ZALLOC_T(pool, pj_ioqueue_t);
+
+    /* Create and init ioqueue mutex */
+    rc = pj_lock_create_null_mutex(pool, "ioq%p", &lock);
+    if (rc != PJ_SUCCESS)
+	return rc;
+
+    rc = pj_ioqueue_set_lock(ioq, lock, PJ_TRUE);
+    if (rc != PJ_SUCCESS)
+	return rc;
+
+    PJ_LOG(4, ("pjlib", "select() I/O Queue created (%p)", ioq));
+
+    *p_ioqueue = ioq;
+    return PJ_SUCCESS;
+}
+
+
+/*
+ * Destroy the I/O queue.
+ */
+PJ_DEF(pj_status_t) pj_ioqueue_destroy( pj_ioqueue_t *ioq )
+{
+    return ioqueue_destroy(ioq);
+}
+
+
+/*
+ * Register a socket to the I/O queue framework. 
+ */
+PJ_DEF(pj_status_t) pj_ioqueue_register_sock( pj_pool_t *pool,
+					      pj_ioqueue_t *ioqueue,
+					      pj_sock_t sock,
+					      void *user_data,
+					      const pj_ioqueue_callback *cb,
+                                              pj_ioqueue_key_t **p_key )
+{
+    return pj_ioqueue_register_sock2(pool, ioqueue, sock, NULL, user_data,
+				     cb, p_key);
+}
+
+PJ_DEF(pj_status_t) pj_ioqueue_register_sock2(pj_pool_t *pool,
+					      pj_ioqueue_t *ioqueue,
+					      pj_sock_t sock,
+					      pj_grp_lock_t *grp_lock,
+					      void *user_data,
+					      const pj_ioqueue_callback *cb,
+                                              pj_ioqueue_key_t **p_key)
+{
+    PjUwpSocketCallback uwp_cb =
+			    { &on_read, &on_write, &on_accept, &on_connect };
+    pj_ioqueue_key_t *key;
+    pj_status_t rc;
+
+    pj_lock_acquire(ioqueue->lock);
+
+    key = PJ_POOL_ZALLOC_T(pool, pj_ioqueue_key_t);
+    rc = ioqueue_init_key(pool, ioqueue, key, sock, grp_lock, user_data, cb);
+    if (rc != PJ_SUCCESS) {
+	key = NULL;
+	goto on_return;
+    }
+
+    /* Create ioqueue key lock, if not yet */
+    if (!key->lock) {
+	rc = pj_lock_create_simple_mutex(pool, NULL, &key->lock);
+	if (rc != PJ_SUCCESS) {
+	    key = NULL;
+	    goto on_return;
+	}
+    }
+
+    PjUwpSocket *s = (PjUwpSocket*)sock;
+    s->SetNonBlocking(&uwp_cb, key);
+
+on_return:
+    if (rc != PJ_SUCCESS) {
+	if (key && key->grp_lock)
+	    pj_grp_lock_dec_ref_dbg(key->grp_lock, "ioqueue", 0);
+    }
+    *p_key = key;
+    pj_lock_release(ioqueue->lock);
+
+    return rc;
+
+}
+
+/*
+ * Unregister from the I/O Queue framework. 
+ */
+PJ_DEF(pj_status_t) pj_ioqueue_unregister( pj_ioqueue_key_t *key )
+{
+    pj_ioqueue_t *ioqueue;
+
+    PJ_ASSERT_RETURN(key, PJ_EINVAL);
+
+    ioqueue = key->ioqueue;
+
+    /* Lock the key to make sure no callback is simultaneously modifying
+     * the key. We need to lock the key before ioqueue here to prevent
+     * deadlock.
+     */
+    pj_ioqueue_lock_key(key);
+
+    /* Also lock ioqueue */
+    pj_lock_acquire(ioqueue->lock);
+
+    /* Close socket. */
+    pj_sock_close(key->fd);
+
+    /* Clear callback */
+    key->cb.on_accept_complete = NULL;
+    key->cb.on_connect_complete = NULL;
+    key->cb.on_read_complete = NULL;
+    key->cb.on_write_complete = NULL;
+
+    pj_lock_release(ioqueue->lock);
+
+    if (key->grp_lock) {
+	pj_grp_lock_t *grp_lock = key->grp_lock;
+	pj_grp_lock_dec_ref_dbg(grp_lock, "ioqueue", 0);
+	pj_grp_lock_release(grp_lock);
+    } else {
+	pj_ioqueue_unlock_key(key);
+    }
+
+    pj_lock_destroy(key->lock);
+
+    return PJ_SUCCESS;
+}
+
+
+/*
+ * Poll the I/O Queue for completed events.
+ */
+PJ_DEF(int) pj_ioqueue_poll( pj_ioqueue_t *ioq,
+			     const pj_time_val *timeout)
+{
+    /* Polling is not necessary on UWP, since each socket handles
+     * its events already.
+     */
+    PJ_UNUSED_ARG(ioq);
+
+    pj_thread_sleep(PJ_TIME_VAL_MSEC(*timeout));
+
+    return 0;
+}
+
Index: /pjproject/trunk/pjlib/src/pj/ip_helper_winphone8.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/ip_helper_winphone8.c	(revision 5539)
+++ /pjproject/trunk/pjlib/src/pj/ip_helper_winphone8.c	(revision 5539)
@@ -0,0 +1,55 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#include <pj/config.h>
+
+#include <pj/ip_helper.h>
+#include <pj/assert.h>
+#include <pj/errno.h>
+#include <pj/string.h>
+
+/*
+ * Enumerate the local IP interface currently active in the host.
+ */
+PJ_DEF(pj_status_t) pj_enum_ip_interface(int af,
+					 unsigned *p_cnt,
+					 pj_sockaddr ifs[])
+{
+    PJ_UNUSED_ARG(af);
+    PJ_UNUSED_ARG(ifs);
+
+    PJ_ASSERT_RETURN(p_cnt, PJ_EINVAL);
+
+    *p_cnt = 0;
+
+    return PJ_ENOTSUP;
+}
+
+/*
+ * Enumerate the IP routing table for this host.
+ */
+PJ_DEF(pj_status_t) pj_enum_ip_route(unsigned *p_cnt,
+				     pj_ip_route_entry routes[])
+{
+    PJ_UNUSED_ARG(routes);
+    PJ_ASSERT_RETURN(p_cnt, PJ_EINVAL);
+
+    *p_cnt = 0;
+
+    return PJ_ENOTSUP;
+}
Index: /pjproject/trunk/pjlib/src/pj/os_core_win32.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/os_core_win32.c	(revision 5538)
+++ /pjproject/trunk/pjlib/src/pj/os_core_win32.c	(revision 5539)
@@ -39,4 +39,8 @@
 #endif
 
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+#   include "../../../third_party/threademulation/include/ThreadEmulation.h"
+#endif
+
 /* Activate mutex related logging if PJ_DEBUG_MUTEX is set, otherwise
  * use default level 6 logging.
@@ -298,5 +302,10 @@
 PJ_DEF(int) pj_thread_get_prio(pj_thread_t *thread)
 {
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    PJ_UNUSED_ARG(thread);
+    return -1;
+#else
     return GetThreadPriority(thread->hthread);
+#endif
 }
 
@@ -313,5 +322,9 @@
 		     PJ_EINVAL);
 
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    if (SetThreadPriorityRT(thread->hthread, prio) == FALSE)
+#else
     if (SetThreadPriority(thread->hthread, prio) == FALSE)
+#endif
 	return PJ_RETURN_OS_ERROR(GetLastError());
 
@@ -474,4 +487,8 @@
     pj_thread_t *rec;
 
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    PJ_UNUSED_ARG(stack_size);
+#endif
+
     PJ_CHECK_STACK();
     PJ_ASSERT_RETURN(pool && proc && thread_ptr, PJ_EINVAL);
@@ -507,7 +524,15 @@
     rec->proc = proc;
     rec->arg = arg;
-    rec->hthread = CreateThread(NULL, stack_size, 
-				thread_main, rec,
-				dwflags, &rec->idthread);
+
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    rec->hthread = CreateThreadRT(NULL, 0,
+				  thread_main, rec,
+				  dwflags, NULL);
+#else
+    rec->hthread = CreateThread(NULL, stack_size,
+			        thread_main, rec,
+			        dwflags, &rec->idthread);
+#endif
+
     if (rec->hthread == NULL)
 	return PJ_RETURN_OS_ERROR(GetLastError());
@@ -541,5 +566,9 @@
     PJ_ASSERT_RETURN(p, PJ_EINVAL);
 
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    if (ResumeThreadRT(rec->hthread) == (DWORD)-1)
+#else
     if (ResumeThread(rec->hthread) == (DWORD)-1)
+#endif    
         return PJ_RETURN_OS_ERROR(GetLastError());
     else
@@ -585,5 +614,9 @@
     PJ_LOG(6, (pj_thread_this()->obj_name, "Joining thread %s", p->obj_name));
 
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    rc = WaitForSingleObjectEx(rec->hthread, INFINITE, FALSE);
+#else
     rc = WaitForSingleObject(rec->hthread, INFINITE);
+#endif    
 
     if (rc==WAIT_OBJECT_0)
@@ -617,5 +650,11 @@
 {
     PJ_CHECK_STACK();
+
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    SleepRT(msec);
+#else
     Sleep(msec);
+#endif
+
     return PJ_SUCCESS;
 }
@@ -811,5 +850,9 @@
     //PJ_CHECK_STACK();
 
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    *index = TlsAllocRT();
+#else
     *index = TlsAlloc();
+#endif
 
     if (*index == TLS_OUT_OF_INDEXES)
@@ -825,5 +868,9 @@
 {
     PJ_CHECK_STACK();
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    TlsFreeRT(index);
+#else
     TlsFree(index);
+#endif    
 }
 
@@ -838,5 +885,11 @@
     //beginning before main thread is initialized.
     //PJ_CHECK_STACK();
+
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    rc = TlsSetValueRT(index, value);
+#else
     rc = TlsSetValue(index, value);
+#endif
+    
     return rc!=0 ? PJ_SUCCESS : PJ_RETURN_OS_ERROR(GetLastError());
 }
@@ -850,5 +903,9 @@
     //by PJ_CHECK_STACK() itself!!!
     //PJ_CHECK_STACK();
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    return TlsGetValueRT(index);
+#else
     return TlsGetValue(index);
+#endif
 }
 
@@ -859,5 +916,7 @@
     PJ_CHECK_STACK();
 
-#if PJ_WIN32_WINNT >= 0x0400
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    InitializeCriticalSectionEx(&mutex->crit, 0, 0);
+#elif PJ_WIN32_WINNT >= 0x0400
     InitializeCriticalSection(&mutex->crit);
 #else
@@ -1113,5 +1172,13 @@
 
     sem = pj_pool_alloc(pool, sizeof(*sem));    
+
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    /** SEMAPHORE_ALL_ACCESS **/
+    sem->hSemaphore = CreateSemaphoreEx(NULL, initial, max, NULL, 0,
+					SEMAPHORE_ALL_ACCESS);
+#else
     sem->hSemaphore = CreateSemaphore(NULL, initial, max, NULL);
+#endif
+    
     if (!sem->hSemaphore)
 	return PJ_RETURN_OS_ERROR(GetLastError());
@@ -1143,6 +1210,11 @@
     LOG_MUTEX((sem->obj_name, "Semaphore: thread %s is waiting", 
 			      pj_thread_this()->obj_name));
-
+    
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    result = WaitForSingleObjectEx(sem->hSemaphore, timeout, FALSE);
+#else
     result = WaitForSingleObject(sem->hSemaphore, timeout);
+#endif
+
     if (result == WAIT_OBJECT_0) {
 	LOG_MUTEX((sem->obj_name, "Semaphore acquired by thread %s", 
@@ -1241,6 +1313,12 @@
         return PJ_ENOMEM;
 
-    event->hEvent = CreateEvent(NULL, manual_reset?TRUE:FALSE, 
-				initial?TRUE:FALSE, NULL);
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    event->hEvent = CreateEventEx(NULL, NULL,
+				 (manual_reset? 0x1:0x0) | (initial? 0x2:0x0),
+				 EVENT_ALL_ACCESS);
+#else
+    event->hEvent = CreateEvent(NULL, manual_reset ? TRUE : FALSE,
+			        initial ? TRUE : FALSE, NULL);
+#endif
 
     if (!event->hEvent)
@@ -1274,5 +1352,10 @@
 			        pj_thread_this()->obj_name));
 
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    result = WaitForSingleObjectEx(event->hEvent, timeout, FALSE);
+#else
     result = WaitForSingleObject(event->hEvent, timeout);
+#endif
+
     if (result == WAIT_OBJECT_0) {
 	PJ_LOG(6, (event->obj_name, "Event: thread %s is released", 
@@ -1332,4 +1415,9 @@
 PJ_DEF(pj_status_t) pj_event_pulse(pj_event_t *event)
 {
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    PJ_UNUSED_ARG(event);
+    pj_assert(!"pj_event_pulse() not supported!");
+    return PJ_ENOTSUP;
+#else
     PJ_CHECK_STACK();
     PJ_ASSERT_RETURN(event, PJ_EINVAL);
@@ -1338,7 +1426,8 @@
 
     if (PulseEvent(event->hEvent))
-        return PJ_SUCCESS;
+	return PJ_SUCCESS;
     else
-        return PJ_RETURN_OS_ERROR(GetLastError());
+	return PJ_RETURN_OS_ERROR(GetLastError());
+#endif
 }
 
Index: /pjproject/trunk/pjlib/src/pj/os_info.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/os_info.c	(revision 5538)
+++ /pjproject/trunk/pjlib/src/pj/os_info.c	(revision 5539)
@@ -197,4 +197,7 @@
 #elif defined(_MSC_VER)
     {
+    #if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+	si.os_name = pj_str("winphone");
+    #else
 	OSVERSIONINFO ovi;
 
@@ -211,4 +214,5 @@
 	    si.os_name = pj_str("win32");
 	#endif
+    #endif
     }
 
@@ -216,7 +220,13 @@
 	SYSTEM_INFO wsi;
 
+    #if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+	GetNativeSystemInfo(&wsi);
+    #else
 	GetSystemInfo(&wsi);
+    #endif
+	
 	switch (wsi.wProcessorArchitecture) {
-    #if defined(PJ_WIN32_WINCE) && PJ_WIN32_WINCE
+	#if (defined(PJ_WIN32_WINCE) && PJ_WIN32_WINCE) || \
+	    (defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8)
 	case PROCESSOR_ARCHITECTURE_ARM:
 	    si.machine = pj_str("arm");
@@ -225,5 +235,5 @@
 	    si.machine = pj_str("shx");
 	    break;
-    #else
+	#else
 	case PROCESSOR_ARCHITECTURE_AMD64:
 	    si.machine = pj_str("x86_64");
@@ -235,6 +245,10 @@
 	    si.machine = pj_str("i386");
 	    break;
-    #endif	/* PJ_WIN32_WINCE */
+	#endif	/* PJ_WIN32_WINCE */
 	}
+    #if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+	/* Avoid compile warning. */
+	goto get_sdk_info;
+    #endif
     }
 #elif defined(PJ_SYMBIAN) && PJ_SYMBIAN != 0
